FUNCTION pline
PARAMETERS pt_str, pt_wid, pt_line, pt_aname, pt_font, ;
           pt_fsize, pt_fstyle
PRIVATE pt_cur_wid, pt_chop, pt_word, pt_isarr, ;
        pt_xx, pt_rvalue

*  pline(<expC1>,<expN1>,<expN2>,[,<@ArrayName>][,<expC2>,;*
*          <expN3>,<expC3>])                               *
*                                                          *
*  Note: Function returns a specified line from a text     *
*  string.                                                 *

EXTERNAL ARRAY pt_aname

***  are we pulling from an array?

pt_isarr =  type('pt_aname[1]') # 'U'
m.pt_rvalue = ''

***  if from an array, get the line

IF pt_isarr .and. ;
   type('pt_aname[pt_line]') = 'C'

  pt_rvalue = pt_aname[pt_line]

***  if we have to chop through the string

ELSE

  IF parameters() <= 4
    m.pt_font = wfont(1)
    m.pt_fsize = wfont(2)
    m.pt_fstyle = wfont(3)
  ELSE

    IF parameters() = 6       &&  no array name passed
      m.pt_fstyle = m.pt_fsize
      m.pt_fsize = m.pt_font
      m.pt_font = m.pt_aname
    ENDIF

  ENDIF

  IF type('m.pt_str') = 'C' .and. ;
     type('m.pt_wid') = 'N' .and. ;
     m.pt_wid >= 8 .and. ;
     type('m.pt_line') = 'N'

    m.pt_cur_wid = set('memowidth')
    SET MEMOWIDTH TO m.pt_wid

    m.pt_xx = 1
    m.pt_rvalue = ''

    DO CASE

***  Windows and proportionally-spaced fonts

      CASE _windows .and. ;
         (txtwidth('i', m.pt_font, 10) # 1 .or. ;
          txtwidth('W', m.pt_font, 10) # 1)

        DO WHILE .not. empty(m.pt_str)
          m.pt_str = alltrim(m.pt_str) + ' '
          m.pt_chop = mline(m.pt_str,1)

          DO CASE 

***  if text width less than line width add words

            CASE txtwidth(m.pt_chop, m.pt_font, ;
                          m.pt_fsize, m.pt_fstyle) < ;
                          m.pt_wid
              m.pt_str = substr(m.pt_str, len(m.pt_chop)+1)

              DO WHILE .t.
                m.pt_word = left(m.pt_str, ;
                               at(' ',m.pt_str) - 1)

***  watch out for carriage returns when adding 
***  words to string.  If found, break line there.

                IF chr(13) $ m.pt_word

                  IF txtwidth(m.pt_chop, m.pt_font, ;
                              m.pt_fsize, m.pt_fstyle) + ;
                     txtwidth(left(m.pt_word, ;
                       at(chr(13), m.pt_word) -1), ;
                       m.pt_font,m.pt_fsize,m.pt_fstyle) <= ;
                     m.pt_wid

                    m.pt_chop = m.pt_chop + left(m.pt_word,;
                              at(chr(13), m.pt_word)-1)
                    m.pt_str = substr(m.pt_str, at(chr(13),;
                                    m.pt_str) + 2)
                  ENDIF

                  EXIT
                ENDIF

***  if last word makes text width greater than 
***  the line length, do not add it and go to 
***  next line.

                IF txtwidth(m.pt_chop+m.pt_word,m.pt_font, ;
                            m.pt_fsize, m.pt_fstyle) > ;
                            m.pt_wid
                  EXIT
                ELSE
                  m.pt_chop = m.pt_chop + m.pt_word + ' '
                  m.pt_str = ltrim(substr(m.pt_str, ;
                                 len(m.pt_word) + 1))
                ENDIF

              ENDDO

***  if the text width is greater than the line
***  length, chop words off line and add them back 
***  to the string until the line fits fits.

            CASE txtwidth(m.pt_chop, m.pt_font, m.pt_fsize,;
                          m.pt_fstyle) > m.pt_wid
              m.pt_str = substr(m.pt_str, len(m.pt_chop)+1)

              DO WHILE .t.
                m.pt_word = substr(m.pt_chop, ;
                                   rat(' ',m.pt_chop))
                m.pt_str = ltrim(m.pt_word) + m.pt_str
                m.pt_chop = trim(left(m.pt_chop, ;
                                 len(m.pt_chop)- ;
                                 len(m.pt_word)))

***  check to see if string is now less than the width

                IF txtwidth(m.pt_chop, m.pt_font,;
                            m.pt_fsize, m.pt_fstyle) < ;
                     m.pt_wid
                  EXIT
                ENDIF

              ENDDO

***  if text width equals the line width

            CASE txtwidth(m.pt_chop, m.pt_font, m.pt_fsize,;
                          m.pt_fstyle) = m.pt_wid
              m.pt_str = substr(m.pt_str, len(m.pt_chop)+1)

          ENDCASE

***  if we are at the right line return it.  Otherwise
***  go on to the next line.

          IF m.pt_xx = m.pt_line 
            m.pt_rvalue = trim(m.pt_chop)
            EXIT
          ELSE
            m.pt_xx = m.pt_xx + 1
          ENDIF

        ENDDO
*** if we are in FPW but are using a monospaced font
*** or if we are in DOS just use FoxPro mline function

      OTHERWISE
        m.pt_rvalue = mline(m.pt_str,m.pt_line)

    ENDCASE

    SET MEMOWIDTH TO (pt_cur_wid)

  ENDIF

ENDIF

RETURN(pt_rvalue)